EvaluateScript("SphereWin.js");
EvaluateScript("tnb_console.js");
EvaluateScript("json2.js");
screen_color = CreateColor(0,45,27,255)

var grid_size = 6

var grid = Array();
var covered = Array();

var box_colors = [CreateColor(255,128,128,255),
                  CreateColor(128,128,255,255),
                  CreateColor(128,128,128,255),
                  CreateColor(128,255,128,255),
                  CreateColor(0  ,255,255,255),
                  CreateColor(255,255,0  ,255)];


var borders = Array();

function for_range (min, max, func) {
   for (var i = min; i < max; i++)
      func(i);
}

function set(x,y,val) {
   grid[x + "," + y] = val;
}
function get(x,y) {
   return grid[x + "," + y];
}
function randIntIn(n,x) {
   return Math.floor(Math.random()*(x-n))+n;
}

function generateGrid (size) {
   for_range(0,size,function (x) {
      for_range(0,size,function (y) {
         set(x,y,randIntIn(0,6));
      });   
   });
   grid_size = size;
   var par = size * 2 - (Math.floor(size / 10));
   covered = [];
   borders = [];
   borderContiguousRegion(0,0);
   return par;
}

function drawHorizontalBorder(x,y,box_size) {
   Rectangle(x * box_size,y * box_size - 1,box_size, 2, CreateColor(0,0,0,255));
}
function drawVerticalBorder(x,y,box_size) {
   Rectangle(x * box_size - 1,y * box_size, 2, box_size,CreateColor(0,0,0,255));
}

function pushHorizontalBorder(x,y) {
   borders.push({type: 'h', x: x, y: y});
}

function pushVerticalBorder(x,y) {
   borders.push({type: 'v', x: x, y: y});
}

function borderContiguousRegion (x, y) {
   if (covered [x+","+y]) return;
   covered[x+","+y] = true;
   if (x > 0 && get(x-1,y) == get(x,y))
      borderContiguousRegion(x-1,y);
   else if (x > 0 && get(x-1,y) != get(x,y))
      pushVerticalBorder(x,y); 
   
   if (x < grid_size  && get(x+1,y) == get(x,y))
      borderContiguousRegion(x+1,y);
   else if (x < grid_size - 1 && get(x+1,y) != get(x,y))
      pushVerticalBorder(x+1,y);

   if (y > 0 && get(x,y-1) == get(x,y))
      borderContiguousRegion(x,y-1);
   else if (y > 0 && get(x,y-1) != get(x,y))
      pushHorizontalBorder(x,y);
 
   if (y < grid_size - 1 && get(x,y+1) == get(x,y))
      borderContiguousRegion(x,y+1);
   else if (y < grid_size - 1 && get(x,y+1) != get(x,y))
      pushHorizontalBorder(x,y+1);
}

function drawGrid ( ) {
   var box_size = 600 / grid_size;
   for_range(0,grid_size,function (x) {
      for_range(0,grid_size,function (y) {
         Rectangle(Math.round(x * box_size), Math.round(y * box_size),Math.round(box_size)+1, Math.round(box_size)+1, box_colors[get(x,y)]);
      });
   });
   drawBorders(box_size);
}

function isGameComplete ( ) {
   for (var x = 0; x < grid_size; x++) {
      for (var y = 0; y < grid_size; y++) {
         if (!covered[x+","+y]) return false;
      }
   }
   return true;
}

function fillColor (color) {
   for (var x = 0; x < grid_size; x++) {
      for (var y = 0; y < grid_size; y++) {
         if (covered[x+","+y]) set(x,y,color);
      }
   }
   return false;
}

function drawBorders (box_size) {
   for (i in borders) {
      if (borders[i].type == 'v') drawVerticalBorder   (borders[i].x, borders[i].y, box_size);
      if (borders[i].type == 'h') drawHorizontalBorder (borders[i].x, borders[i].y, box_size);

   }
}

function doGame (gridSize) {
   InitializeSphereWin();
   do {
      var par = generateGrid (gridSize);
   } while (isGameComplete());
   var moves = 0;
   var gameOver = false;
   AddtoScreen(new button(610,538,"Exit",
         function() {
            gameOver = true;
            moves = -32767 + par;
         },
   180,48));
   AddtoScreen(new button(610,10,"",
         function() {
            if (get(0,0) != 0) {
               fillColor(0);
               moves++;
               covered = [];
               borders = [];
               borderContiguousRegion(0,0);
            }
         },
   180,48,box_colors[0]));
   AddtoScreen(new button(610,68,"",
         function() {
            if (get(0,0) != 1) {
               fillColor(1);
               moves++;
               covered = [];
               borders = [];
               borderContiguousRegion(0,0);
            }
         },
   180,48,box_colors[1]));
   AddtoScreen(new button(610,128,"",
         function() {
            if (get(0,0) != 2) {
               fillColor(2);
               moves++;
               covered = [];
               borders = [];
               borderContiguousRegion(0,0);
            }
         },
   180,48,box_colors[2]));
   AddtoScreen(new button(610,188,"",
         function() {
            if (get(0,0) != 3) {
               fillColor(3);
               moves++;
               covered = [];
               borders = [];
               borderContiguousRegion(0,0);
            }
         },
   180,48,box_colors[3]));
   AddtoScreen(new button(610,248,"",
         function() {
            if (get(0,0) != 4) {
               fillColor(4);
               moves++;
               covered = [];
               borders = [];
               borderContiguousRegion(0,0);
            }
         },
   180,48,box_colors[4]));
   AddtoScreen(new button(610,308,"",
         function() {
            if (get(0,0) != 5) {
               fillColor(5);
               moves++;
               covered = [];
               borders = [];
               borderContiguousRegion(0,0);
            }
         },
   180,48,box_colors[5]));
          
   while(!gameOver) { 
      drawGrid ();
      UpdateSphereWin();
      DrawSphereWin();
      text(700 - w("Par: " + par)/2,screen.h - 200,"Par: " + par) //draws text to the screen
      text(700 - w("Moves: " + moves)/2,screen.h - 170,"Moves: " + moves) //draws text to the screen
      FlipScreen();
      if (isGameComplete())
         gameOver = true;
   }
   return (moves - par);
}

var slidervalue = 6;
function w (text) {
  return systemfont_white.getStringWidth(text);
}
function game () {
   InitializeSphereWin();
   var ws = GetSystemWindowStyle();
   function addCtrls() {
      AddtoScreen(new slider(screen.w/2 - 100,screen.h / 2 - 10,4,50,"Level Size:",'slidervalue',200));
      AddtoScreen(new button(screen.w / 2 - w("Play")/2,screen.h / 2 + 50,"Play",
            function() {
                var score = doGame (roundto(slidervalue,0));
                InitializeSphereWin();
                addCtrls();
                if (score > -32767) {
                   if (score <= 0)
                      slidervalue += 1;
                   var scores = [];
                   var fil = OpenFile("scores.dat");
                   scores = JSON.parse(fil.read("level" + grid_size ,"[]"));
                   var cons = new Console(screen.w / 4 + screen.w / 8, screen.h / 4 + screen.h / 8 + 64, screen.w / 4, screen.h / 4 + 16);
                   if (scores.length < 10 || score < scores[9].score) {
                      cons.print("For this level, you scored " + score + " (Lower is better).\n Please Enter your name for the high score board.\n\n");
                      var name = cons.input("");
                      if (name.length > 15) name = name.slice(0,15);
                      scores.push({name: name, score: score });
                      scores.sort(function (a,b) {
                         return a.score - b.score; 
                      }); 
                   }
                   cons.clear();
                   cons.print("High Scores\n----------------\n");
                   for (i in scores) 
                      if (i < 10) cons.print((i - -1) + ". " + scores[i].score  +  " - " + scores[i].name + "\n");
                   cons.print("Press a key...");
                   while (AreKeysLeft()) GetKey();
                   cons.render();
                   FlipScreen();
                   GetKey();
                   fil.write("level" + grid_size, JSON.stringify(scores));
                }
            }
      ));
      AddtoScreen(new button(screen.w / 2 - w("Reset Scores")/2,screen.h / 2 + 74,"Reset Scores",
               function () {
                  RemoveFile("save/scores.dat");
                  var cons = new Console(screen.w / 4 + screen.w / 8, screen.h / 4 + screen.h / 8 + 64, screen.w / 4, screen.h / 8);
                  cons.print("Scores Cleared!\nPress a key...");
                  while (AreKeysLeft()) GetKey();
                  cons.render();
                  FlipScreen();
                  GetKey();
               }));
      AddtoScreen(new button(screen.w / 2 - w("Exit")/2,screen.h / 2 + 98,"Exit",
               function () {
                   Exit();
               }));
   }

   addCtrls();
   while (true) { 
      text(screen.w/2 - w("ADAPT")/2,screen.h / 4,"ADAPT") //draws text to the screen
      text(screen.w/2 - w("ADAPT")/2 + 1,screen.h / 4,"ADAPT") //draws text to the screen
      text(screen.w/2 - w("_____")/2,screen.h / 4 + 2,"_____") //draws text to the screen
      text(screen.w/2 - w("_____")/2 + 3,screen.h / 4 + 2,"_____") //draws text to the screen
      text(screen.w/2 - w("An addictive game by Kamatsu")/2,screen.h / 4 + 50,"An addictive game by Kamatsu");
      UpdateSphereWin();
      ws.drawWindow(screen.w / 2 - 100, screen.h /4 + 125, 200, 150);
      DrawSphereWin();
      FlipScreen();
      
   }

}
